function vol=Volumes_amat(q,me)
  % computes volumes of all d-simplex
  % d-simplex in R^n (d<=n)
  % 
  [dim,d,nq,nme]=fc_meshtools.simplicial.get_dims(q,me);
  if d==0, vol=1;return;end
  At=zeros(d,dim,nme);
  for i=1:d 
    At(i,:,:)=q(:,me(i+1,:))-q(:,me(1,:));
  end
  At=amat(permute(At,[3,1,2]));
  if dim==d
    vol=abs(det(At))/factorial(d);
  else 
    vol=sqrt(det(At*At'))/factorial(d);
  end
  vol=vol(:)';
end 

