function varargout=eval2D02(varargin)
  fprintf('************************************\n')
  fprintf('  Running %s function\n',mfilename())
  fprintf('************************************\n')
  [Th,verbose]=fc_simesh.demos.setMesh2D(varargin{:});
  
  g1=@(x,y) cos(x).*sin(y);
  g2=@(q) cos(q(1,:)).*sin(q(2,:));

  % Cannot define g3 and g4 here with Octave, error message:
  %   'handles to nested functions are not yet supported'
  % but it's OK with Matlab 2017a
  
  if verbose,fprintf('*** Computing functions on mesh\n');end
  z1=Th.eval(g1);
  z2=Th.eval(g2);
  z3=Th.eval(@g3);
  z4=Th.eval(@g4);
  
  if verbose,fprintf('*** Check results\n');end
  res=0;
  res=res+ ~( (size(z1,1)==Th.nq) && (size(z2,1)==Th.nq) && (size(z3,1)==Th.nq) && (size(z4,1)==Th.nq) );
  if verbose, if (res==1),    fprintf('  Test 0: failed with dimensions\n');else fprintf('  Test 0: OK\n');end;end
  E=max(abs(z2-z1));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 1: failed with E=%g\n',E);else fprintf('  Test 1: OK\n');end;end
  E=max(abs(z3-z1));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 2: failed with E=%g\n',E);else fprintf('  Test 2: OK\n');end;end
  E=max(abs(z4-z1));
  res=res+(E >1e-15);
  if verbose, if (E >1e-15),fprintf('  Test 3: failed with E=%g\n',E);else fprintf('  Test 3: OK\n');end;end
  if res>0,error('demo % failed',mfilename()');end
  if nargout==1,varargout{1}=Th;end
end

function z=g3(x,y)
  z=cos(x).*sin(y);
end

function z=g4(q)
  z=cos(q(1,:)).*sin(q(2,:));
end
  
